
#include "pts.h"

const struct timeval cPTS::atzero = { 0, 0 };

void cPTS::clear()
{
	pts = 0;
	stc = 0;
	l_pts = 0;
	l_stc = 0;
	start_pts=0;
	start_stc=0;
	delay_sum=0;
	memset(atregs, 0, sizeof(atregs)); 
	memset(dtregs, 0, sizeof(dtregs)); 
}

int cPTS::process( const uint_8 *ptsdata, uint_32 stc, int sleep_threshold)
{
	if ( ptsdata==NULL) 
		return 0;

	if ( stc == 0 ) 
		return 0;

	mark(ptsdata); //  pts setup

	return process ( stc, sleep_threshold );

}

int cPTS::process( uint_32 stc, int sleep_threshold)
{
	int     delay_pts;
	// int     delay_pts_d;
	uint_32 u_sleep;

	this->stc = stc;

	// if cleared -> setup
	if ( start_pts==0 || start_stc==0 ) {
		start_stc=stc;
		start_pts=pts;
		l_stc=stc;
		l_pts=pts;
		debug_pts("PTS mark reset start stc, pts: %4lums, %4lums\n", stc, pts);
	}

 	if(stc>pts) {
		delay_pts = (int)(stc-pts) ;	 // late
	} else {
		delay_pts = (int)(pts-stc) * -1; // early
	}

/*
 	if((stc-start_stc)>(pts-start_pts)) {
		delay_pts_d = (int)((stc-start_stc)-(pts-start_pts)) ;
	} else {
		delay_pts_d = (int)((pts-start_pts)-(stc-start_stc)) * -1;
	}
	delay_pts = delay_pts_d;
 */

	delay_sum += delay_pts;

	debug_pts("PTSDIFF stc-pts: %9lums (d%4lums) - %9lums (d%4lums) = %4dms; sum %4dms; ", 
		stc, stc-l_stc, pts, pts-l_pts, delay_pts, delay_sum
	);

	if(abs(delay_pts)>5000) {
		delay_pts=0;
	}

	if ( delay_pts > 5 ) {
		;
	}  
	else if ( sleep_threshold>0 && delay_pts < sleep_threshold*-1 ) {
		u_sleep=(delay_pts+sleep_threshold)*-1000;

    		(void) getLastTimeDiff();

		usleep ( u_sleep );

		debug_pts(" sleep %4lums (%4dms)", 
			u_sleep/1000, getLastTimeDiff());
	}
	debug_pts("\n");
	l_stc=stc;
	l_pts=pts;

	return delay_pts;
}
